﻿using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class AnswerUI : MonoBehaviour {
	public List<Text> answerText;
	public string questionTitle;
	public string convoReturnName;
	public List<Message> responses;
	public List<string> answerLong;
	
	public void setAnswers(string convoName, string questionName, List<string> answers, List<Message> responseList, List<string> inputAnswerLong){
		answerLong = inputAnswerLong;
		responses = responseList;
		convoReturnName = convoName;
		questionTitle = questionName;
		if(answers == null || answers.Count == 0){
			Debug.Log("Nothing to ask, mocing on.");
			return;
		}

		for (int i = 0; i < answerText.Count; i++)
		{
			if(i < answers.Count){
				answerText[i].text = answers[i];
			}else{
				answerText[i].transform.parent.gameObject.SetActive(false);
			}
		}
		RectTransform rect = gameObject.GetComponent<RectTransform>();
		rect.offsetMin = new Vector2(0f, 0f);
		rect.offsetMax = new Vector2(0f, 0f);
		rect.sizeDelta = new Vector2(0f, 150f);
	}
	public void returnAnswer(int answer){
		if(questionTitle != null && questionTitle != "")
			StateManager.Instance().setChoice(questionTitle, answer);

		DisplayManager.Instance().sendResponse(convoReturnName, responses[answer], new PlayerMessage(answerLong[answer], 1f));
		Destroy(gameObject);
	}
}
