﻿using System.Collections.Generic;
using UnityEngine;
using System;
public class ChatDisplay : MonoBehaviour {
     public float size = 300f;
     public string chatName; 
     public GameObject textPrefab;
     public GameObject answerPrefab;
     public GameObject playerMessagePrefab;
     public GameObject chatContainer;
     private float messageOffset;
     
    
    private List<object> displayList;

    public void displayIntro(){
        
    }
    
    public void addNarrativeBlock(object block)
    {
        if(displayList == null)
            displayList = new List<object>();
            
        Debug.Log("Adding block " + block.ToString());
        displayList.Add(block);
    }
    public void clearChat(){
        for (int i = chatContainer.transform.childCount-1; i >= 0; i--)
        {
            Destroy(chatContainer.transform.GetChild(i).gameObject);
        }
        displayList = null;
        messageOffset = 0;
    }
    public void deliverText(string text)
    {
        GameObject newChatObject = GameObject.Instantiate(textPrefab);
        newChatObject.transform.SetParent(chatContainer.transform);
        newChatObject.GetComponent<MessageUI>().setMessage(messageOffset, text, size);
  //      newChatObject.Find("");
        messageOffset+=size;
        DisplayManager.Instance().messengerWindow.GetComponent<RectTransform>().sizeDelta = new Vector2(0f, messageOffset);
    }
    public void deliverAnswer(string answerName, List<string> answers, List<Message> responses, List<string> answersLong)
    {
        GameObject newChatObject = GameObject.Instantiate(answerPrefab);
        newChatObject.transform.SetParent(chatContainer.transform);
        newChatObject.GetComponent<AnswerUI>().setAnswers(chatName, answerName, answers, responses, answersLong);
    }
    public void deliverPlayerText(string text)
    {
        GameObject newChatObject = GameObject.Instantiate(playerMessagePrefab);
        newChatObject.transform.SetParent(chatContainer.transform);
        newChatObject.GetComponent<MessageUI>().setMessage(messageOffset, text, size);
        messageOffset+=size;
        DisplayManager.Instance().messengerWindow.GetComponent<RectTransform>().sizeDelta = new Vector2(0f, messageOffset);
    }

    void Awake()
    {
        messageOffset = 0;  
    }
    void askForNextContent(){
		ConversationManager.Instance().progressConversation(chatName);
    }
    public void sendResponse(Message response, PlayerMessage playerLongAnswer){
        displayList.Add(playerLongAnswer);
        displayList.Add(response);
    }
    public float nextDisplay = 0f;
    void Update()
    {
        if(displayList!=null && displayList.Count > 0 && nextDisplay < Time.time)
        {
            Type displayType = displayList[0].GetType();
            if(displayType == typeof(Message)){
                Message displayMessage = displayList[0] as Message;
                
                deliverText(displayMessage.text);
                nextDisplay = Time.time + displayMessage.pauseForSecondsAfter;
                displayList.RemoveAt(0);

                if(displayList.Count == 0)
		            ConversationManager.Instance().progressConversation(chatName);
                
            }else if(displayType == typeof(Answer)){
                Answer displayAnswer = displayList[0] as Answer;
                
				deliverAnswer(displayAnswer.answerName, displayAnswer.answersShort, displayAnswer.response,  displayAnswer.answersLong);
                displayList.RemoveAt(0);

            }else if(displayType == typeof(PlayerMessage)){
                PlayerMessage message = displayList[0] as PlayerMessage;
                
				deliverPlayerText(message.text);
                displayList.RemoveAt(0);
                if(displayList.Count == 0)
		            ConversationManager.Instance().progressConversation(chatName);
            }
        }
    }
}