﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class IntroUI : MonoBehaviour {
	public IntroMessage cachedMessage;
	public Text message;
	public Text question1Text;
	public Text question2Text;
	public void setInterUI(IntroMessage introMessage){
		cachedMessage = introMessage;
		message.text = introMessage.text;
		if(introMessage.responses.Count>0)
			question1Text.text = introMessage.responses[0];
		else
			question2Text.transform.parent.gameObject.SetActive(false);
			
		if(introMessage.responses.Count>1)
			question2Text.text = introMessage.responses[1];
		else
			question2Text.transform.parent.gameObject.SetActive(false);

		RectTransform rect = gameObject.GetComponent<RectTransform>();
		rect.sizeDelta = new Vector2(0f, 400f);
		rect.offsetMin = new Vector2(0f, 0f);
		rect.offsetMax = new Vector2(0f, 0f);
	}
	public void returnAnswer(int answer){
		if(cachedMessage.saveID != "" && cachedMessage.saveID != null)
			StateManager.Instance().setChoice(cachedMessage.saveID, answer);

		DisplayManager.Instance().sendResponseIntro(cachedMessage.nextKey);
		Destroy(gameObject);
	}
}
