﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class StateManager : MonoBehaviour {

    private static StateManager instance;

    public static StateManager Instance()
    {
        if (instance == null){
            instance = GameObject.Find("StateManager").GetComponent<StateManager>();
            instance.choices = new Dictionary<string, int>();
        }
        if (instance == null)
            Debug.LogError("Can't find StateManage!");

        return instance;
    }

    Dictionary<string, int> choices;

    public void setChoice(string choice, int value)
    {
        if(choice == null)
            return;
        Debug.Log("Set Choice: " + choice + " " + value);
        if(choices.ContainsKey(choice))
            choices[choice] = value;
        else
            choices.Add(choice, value);
    }

    public bool checkChoice(string choice, int value)
    {
        if(choice == null)
            return false;
        if (choices.ContainsKey(choice))
            return choices[choice] == value;
        else
            return false;
    }

    public int getChoice(string choice)
    {
        if(choice == null)
            return -1;
        if (choices.ContainsKey(choice))
            return choices[choice];
        else
            return -1;
    }
}
